package com.jz.dmp.modules.controller.bean;

import java.util.ArrayList;
import java.util.List;

import org.springframework.beans.BeanUtils;
import com.jz.dmp.modules.controller.sys.bean.DmpMemberDto;
import com.jz.dmp.modules.model.DmpMember;

public class MyDmpMemberConverter {
	
	private static MyDmpMemberConverter instance;
	
	private MyDmpMemberConverter() {};
	
	public synchronized static MyDmpMemberConverter INSTANCE() {
		if (instance==null) {
			instance = new MyDmpMemberConverter();
		}
		
		return instance;
	}
	
	public DmpMemberDto domain2dto(DmpMember dmpMember) {
		if (dmpMember==null) {
			return null;
		}
		
		DmpMemberDto dmpMemberDto = new DmpMemberDto();
		BeanUtils.copyProperties(dmpMember, dmpMemberDto);
		
		return dmpMemberDto;
	}
	
	public List<DmpMemberDto> domain2dto(List<DmpMember> dmpMembers) {
		List<DmpMemberDto> dmpMemberDtos = new ArrayList<DmpMemberDto>();
		dmpMembers.stream().forEach(x -> {
			dmpMemberDtos.add(domain2dto(x));
		});
		
		return dmpMemberDtos;
	}
	
	public DmpMember dto2domain(DmpMemberDto dmpMemberDto) {
		if (dmpMemberDto==null) {
			return null;
		}
		
		DmpMember dmpMember = new DmpMember();
		BeanUtils.copyProperties(dmpMemberDto, dmpMember);
		
		return dmpMember;
	}
	
	public List<DmpMember> dto2domain(List<DmpMemberDto> dmpMemberDtos) {
		List<DmpMember> dmpMembers = new ArrayList<DmpMember>();
		dmpMemberDtos.stream().forEach(x -> {
			dmpMembers.add(dto2domain(x));
		});
		
		return dmpMembers;
	}

}
