package com.jz.dmp.modules.service.projconfig;

import java.util.List;
import javax.servlet.http.HttpServletRequest;
import com.jz.common.bean.BaseBeanResponse;
import com.jz.common.bean.BaseResponse;
import com.jz.common.bean.PageInfoResponse;
import com.jz.dmp.modules.controller.projconfig.bean.DmpProjectConfigEngineBatch;
import com.jz.dmp.modules.controller.projconfig.bean.DmpProjectConfigEngineDto;
import com.jz.dmp.modules.controller.projconfig.bean.DmpProjectConfigEngineRequest;
import com.jz.dmp.modules.model.DmpProjectConfigEngine;

/**
 * 项目配置计算引擎关系表服务接口
 * @author ybz
 *
 */
public interface DmpProjectConfigEngineService {

	/**条件分頁查询所有项目配置计算引擎关系表
	 * @param dmpProjectConfigEngineRequest
	 * @param httpRequest
	 * @return
	 * @throws Exception
	 */
	public PageInfoResponse<DmpProjectConfigEngineDto> findListWithPage(DmpProjectConfigEngineRequest dmpProjectConfigEngineRequest, HttpServletRequest httpRequest)throws Exception;
	
	/**条件查询所有项目配置计算引擎关系表
	 * @param dmpProjectConfigEngineRequest
	 * @param httpRequest
	 * @return
	 * @throws Exception
	 */
	public BaseBeanResponse<DmpProjectConfigEngineDto> findList(DmpProjectConfigEngineRequest dmpProjectConfigEngineRequest, HttpServletRequest httpRequest)throws Exception;

	

	/**新增项目配置计算引擎关系表
	 * @param dmpProjectConfigEngine
	 * @param httpRequest
	 * @return
	 * @throws Exception
	 */
	public BaseBeanResponse<DmpProjectConfigEngine> add(DmpProjectConfigEngine dmpProjectConfigEngine, HttpServletRequest httpRequest)throws Exception;
	
	/**主键查询项目配置计算引擎关系表
	 * @param configEngineId
	 * @param httpRequest
	 * @return
	 * @throws Exception
	 */
	public BaseBeanResponse<DmpProjectConfigEngineDto> findById(Integer configEngineId, HttpServletRequest httpRequest)throws Exception;

	/**修改项目配置计算引擎关系表
	 * @param dmpProjectConfigEngine
	 * @param httpRequest
	 * @return
	 * @throws Exception
	 */
	public BaseBeanResponse<DmpProjectConfigEngine> edit(DmpProjectConfigEngine dmpProjectConfigEngine, HttpServletRequest httpRequest)throws Exception;
	
	/**新增或修改项目配置计算引擎关系表
	 * @param dmpProjectConfigEngine
	 * @param httpRequest
	 * @return
	 * @throws Exception
	 */
	public BaseBeanResponse<DmpProjectConfigEngine> addOrEdit(DmpProjectConfigEngine dmpProjectConfigEngine, HttpServletRequest httpRequest)throws Exception;


	/**主键删除项目配置计算引擎关系表
	 * @param configEngineId
	 * @param httpRequest
	 * @return
	 * @throws Exception
	 */
	public BaseResponse deleteById(Integer configEngineId, HttpServletRequest httpRequest)throws Exception;
	
	/**主键软删除项目配置计算引擎关系表
	 * @param configEngineId
	 * @param httpRequest
	 * @return
	 * @throws Exception
	 */
	public BaseResponse softDeleteById(Integer configEngineId, HttpServletRequest httpRequest)throws Exception;
	
	/**条件删除项目配置计算引擎关系表
	 * @param dmpProjectConfigEngineRequest
	 * @param httpRequest
	 * @return
	 * @throws Exception
	 */
	public BaseResponse delete(DmpProjectConfigEngineRequest dmpProjectConfigEngineRequest, HttpServletRequest httpRequest)throws Exception;
	
	/**条件软删除项目配置计算引擎关系表
	 * @param dmpProjectConfigEngineRequest
	 * @param httpRequest
	 * @return
	 * @throws Exception
	 */
	public BaseResponse softDelete(DmpProjectConfigEngineRequest dmpProjectConfigEngineRequest, HttpServletRequest httpRequest)throws Exception;

	/**批量新增项目配置计算引擎关系表
	 * @param dmpProjectConfigEngineVo
	 * @param httpRequest
	 * @return
	 * @throws Exception
	 */
	public BaseBeanResponse<DmpProjectConfigEngineBatch> addBatch(DmpProjectConfigEngineBatch dmpProjectConfigEngineBatch, HttpServletRequest httpRequest)throws Exception;

	/**  
	* @Title: deleteByIds  
	* @Description: TODO(根据主键批量删除)  
	* @param @param idList
	* @param @param httpRequest
	* @param @return
	* @param @throws Exception    参数  
	* @return BaseResponse    返回类型  
	* @throws  
	*/ 
	public BaseResponse deleteByIds(List<Integer> idList, HttpServletRequest httpRequest)throws Exception;

	/**  
	* @Title: softDeleteByIds  
	* @Description: TODO(根据主键批量软删除)  
	* @param @param idList
	* @param @param httpRequest
	* @param @return
	* @param @throws Exception    参数  
	* @return BaseResponse    返回类型  
	* @throws  
	*/ 
	public BaseResponse softDeleteByIds(List<Integer> idList, HttpServletRequest httpRequest)throws Exception;

}
