package com.jz.dmp.modules.service.projconfig;

import java.util.List;
import javax.servlet.http.HttpServletRequest;
import com.jz.common.bean.BaseBeanResponse;
import com.jz.common.bean.BaseResponse;
import com.jz.common.bean.PageInfoResponse;
import com.jz.dmp.modules.controller.projconfig.bean.DmpPublicConfigInfoBatch;
import com.jz.dmp.modules.controller.projconfig.bean.DmpPublicConfigInfoDto;
import com.jz.dmp.modules.controller.projconfig.bean.DmpPublicConfigInfoRequest;
import com.jz.dmp.modules.model.DmpPublicConfigInfo;

/**
 * 公共配置表服务接口
 * @author ybz
 *
 */
public interface DmpPublicConfigInfoService {

	/**条件分頁查询所有公共配置表
	 * @param dmpPublicConfigInfoRequest
	 * @param httpRequest
	 * @return
	 * @throws Exception
	 */
	public PageInfoResponse<DmpPublicConfigInfoDto> findListWithPage(DmpPublicConfigInfoRequest dmpPublicConfigInfoRequest, HttpServletRequest httpRequest)throws Exception;
	
	/**条件查询所有公共配置表
	 * @param dmpPublicConfigInfoRequest
	 * @param httpRequest
	 * @return
	 * @throws Exception
	 */
	public BaseBeanResponse<DmpPublicConfigInfoDto> findList(DmpPublicConfigInfoRequest dmpPublicConfigInfoRequest, HttpServletRequest httpRequest)throws Exception;

	

	/**新增公共配置表
	 * @param dmpPublicConfigInfo
	 * @param httpRequest
	 * @return
	 * @throws Exception
	 */
	public BaseBeanResponse<DmpPublicConfigInfo> add(DmpPublicConfigInfo dmpPublicConfigInfo, HttpServletRequest httpRequest)throws Exception;
	
	/**主键查询公共配置表
	 * @param publicConfigId
	 * @param httpRequest
	 * @return
	 * @throws Exception
	 */
	public BaseBeanResponse<DmpPublicConfigInfoDto> findById(Integer publicConfigId, HttpServletRequest httpRequest)throws Exception;

	/**修改公共配置表
	 * @param dmpPublicConfigInfo
	 * @param httpRequest
	 * @return
	 * @throws Exception
	 */
	public BaseBeanResponse<DmpPublicConfigInfo> edit(DmpPublicConfigInfo dmpPublicConfigInfo, HttpServletRequest httpRequest)throws Exception;
	
	/**新增或修改公共配置表
	 * @param dmpPublicConfigInfo
	 * @param httpRequest
	 * @return
	 * @throws Exception
	 */
	public BaseBeanResponse<DmpPublicConfigInfo> addOrEdit(DmpPublicConfigInfo dmpPublicConfigInfo, HttpServletRequest httpRequest)throws Exception;


	/**主键删除公共配置表
	 * @param publicConfigId
	 * @param httpRequest
	 * @return
	 * @throws Exception
	 */
	public BaseResponse deleteById(Integer publicConfigId, HttpServletRequest httpRequest)throws Exception;
	
	/**主键软删除公共配置表
	 * @param publicConfigId
	 * @param httpRequest
	 * @return
	 * @throws Exception
	 */
	public BaseResponse softDeleteById(Integer publicConfigId, HttpServletRequest httpRequest)throws Exception;
	
	/**条件删除公共配置表
	 * @param dmpPublicConfigInfoRequest
	 * @param httpRequest
	 * @return
	 * @throws Exception
	 */
	public BaseResponse delete(DmpPublicConfigInfoRequest dmpPublicConfigInfoRequest, HttpServletRequest httpRequest)throws Exception;
	
	/**条件软删除公共配置表
	 * @param dmpPublicConfigInfoRequest
	 * @param httpRequest
	 * @return
	 * @throws Exception
	 */
	public BaseResponse softDelete(DmpPublicConfigInfoRequest dmpPublicConfigInfoRequest, HttpServletRequest httpRequest)throws Exception;

	/**批量新增公共配置表
	 * @param dmpPublicConfigInfoVo
	 * @param httpRequest
	 * @return
	 * @throws Exception
	 */
	public BaseBeanResponse<DmpPublicConfigInfoBatch> addBatch(DmpPublicConfigInfoBatch dmpPublicConfigInfoBatch, HttpServletRequest httpRequest)throws Exception;

	/**  
	* @Title: deleteByIds  
	* @Description: TODO(根据主键批量删除)  
	* @param @param idList
	* @param @param httpRequest
	* @param @return
	* @param @throws Exception    参数  
	* @return BaseResponse    返回类型  
	* @throws  
	*/ 
	public BaseResponse deleteByIds(List<Integer> idList, HttpServletRequest httpRequest)throws Exception;

	/**  
	* @Title: softDeleteByIds  
	* @Description: TODO(根据主键批量软删除)  
	* @param @param idList
	* @param @param httpRequest
	* @param @return
	* @param @throws Exception    参数  
	* @return BaseResponse    返回类型  
	* @throws  
	*/ 
	public BaseResponse softDeleteByIds(List<Integer> idList, HttpServletRequest httpRequest)throws Exception;

	/**  
	* @Title: findOne  
	* @Description: TODO(查询公共配置)  
	* @param @param httpRequest
	* @param @return
	* @param @throws Exception    参数  
	* @return BaseBeanResponse<DmpPublicConfigInfoDto>    返回类型  
	* @throws  
	*/ 
	public BaseBeanResponse<DmpPublicConfigInfoDto> findOne(HttpServletRequest httpRequest)throws Exception;

}
